DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Private Member Functions | List of all members
DiColorRotateTemplate< T > Class Template Reference

Template class to rotate color images (on pixel data level). More...

Inheritance diagram for DiColorRotateTemplate< T >:

## Public Member Functions
| DiColorRotateTemplate (const DiColorPixel *pixel, const Uint16 src_cols, const Uint16 src_rows, const Uint16 dest_cols, const Uint16 dest_rows, const Uint32 frames, const int degree)
| constructor
| ~DiColorRotateTemplate ()
| destructor
Public Member Functions inherited from DiColorPixelTemplate< T >
| DiColorPixelTemplate (const DiDocument *docu, const DiInputPixel *pixel, const Uint16 samples, EI_Status &status, const Uint16 sample_rate=0)
| constructor
virtual | ~DiColorPixelTemplate ()
| destructor
EP_Representation | getRepresentation () const
| get integer representation
const void * | getData () const
| get pointer to internal array of pixel data.
void * | getDataPtr ()
| get pointer to internal array of pixel data.
void * | getDataArrayPtr ()
| get pointer to internal array of pixel data.
OFBool | getPixelData (void *data, const unsigned long count, const unsigned long fcount, const unsigned long frames, const int planar) const
| fill given memory block with pixel data (all three image planes, RGB)
unsigned long | createDIB (void *&data, const unsigned long size, const Uint16 width, const Uint16 height, const unsigned long frame, const int fromBits, const int toBits, const int mode, const int upsideDown, const int padding) const
| create true color (24/32 bit) bitmap for MS Windows.
unsigned long | createAWTBitmap (void *&data, const Uint16 width, const Uint16 height, const unsigned long frame, const int fromBits, const int toBits) const
| create true color (32 bit) bitmap for Java (AWT default format).
Public Member Functions inherited from DiColorPixel
| DiColorPixel (const DiDocument *docu, const DiInputPixel *pixel, const Uint16 samples, EI_Status &status, const Uint16 sample_rate=0)
| constructor
virtual | ~DiColorPixel ()
| destructor
int | getPlanes () const
| get number of planes
int | getPlanarConfiguration () const
| get planar configuration of the original pixel data
Public Member Functions inherited from DiPixel
| DiPixel (const unsigned long count, const unsigned long inputCount=0)
| constructor
virtual | ~DiPixel ()
| destructor
unsigned long | getCount () const
| get number of pixels
unsigned long | getInputCount () const
| get number of pixels stored in the 'PixelData' element
Public Member Functions inherited from DiPixelRepresentationTemplate< T >
| DiPixelRepresentationTemplate ()
| default constructor
virtual | ~DiPixelRepresentationTemplate ()
| destructor
int | isSigned () const
| check whether template type T is signed or not

## Private Member Functions
void | rotate (const T *pixel[3], const int degree)
| rotate pixel data

## Additional Inherited Members
Protected Member Functions inherited from DiColorPixelTemplate< T >
| DiColorPixelTemplate (const DiColorPixel *pixel, const unsigned long count)
| constructor
int | Init (const void *pixel)
| initialize internal memory
Protected Member Functions inherited from DiColorPixel
| DiColorPixel (const DiColorPixel *pixel, const unsigned long count)
| constructor
Protected Member Functions inherited from DiRotateTemplate< T >
void | rotateLeft (const T *src[], T *dest[])
| rotate source image left and store result in destination image
void | rotateRight (const T *src[], T *dest[])
| rotate source image right and store result in destination image
void | rotateTopDown (const T *src[], T *dest[])
| rotate source image top-down and store result in destination image
| DiRotateTemplate (DiPixel *pixel, const Uint16 src_cols, const Uint16 src_rows, const Uint16 dest_cols, const Uint16 dest_rows, const Uint32 frames, const int degree)
| constructor.
| DiRotateTemplate (const int planes, const Uint16 src_cols, const Uint16 src_rows, const Uint16 dest_cols, const Uint16 dest_rows, const Uint32 frames)
| constructor.
virtual | ~DiRotateTemplate ()
| destructor
void | rotateData (const T *src[], T *dest[], const int degree)
| choose algorithm depending on rotation angle
Protected Member Functions inherited from DiTransTemplate< T >
| DiTransTemplate (const int planes, const Uint16 src_x, const Uint16 src_y, const Uint16 dest_x, const Uint16 dest_y, const Uint32 frames, const int bits=0)
| constructor
virtual | ~DiTransTemplate ()
| destructor
void | copyPixel (const T *src[], T *dest[])
| copy pixel data
void | fillPixel (T *dest[], const T value)
| fill pixel data with specified value
void | clearPixel (T *dest[])
| clear pixel data (set values to 0)
Protected Attributes inherited from DiColorPixelTemplate< T >
T * | Data [3]
| pointer to pixel data (3 components)
Protected Attributes inherited from DiColorPixel
int | PlanarConfiguration
| planar configuration of the original pixel data (0 = color-by-pixel, 1 = color-by-plane)
Protected Attributes inherited from DiPixel
unsigned long | Count
| number of pixels
unsigned long | InputCount
| number of pixels in the input buffer
Protected Attributes inherited from DiTransTemplate< T >
int | Planes
| number of planes
Uint16 | Src_X
| width of source image
Uint16 | Src_Y
| height of source image
const Uint16 | Dest_X
| width of destination image
const Uint16 | Dest_Y
| height of destination image
const Uint32 | Frames
| number of frames
const int | Bits
| number of bits per plane/pixel

## Detailed Description

template<class T>
class DiColorRotateTemplate< T >

Template class to rotate color images (on pixel data level).

by steps of 90 degrees

## Constructor & Destructor Documentation

## ◆ DiColorRotateTemplate()

template<class T>

DiColorRotateTemplate< T >::DiColorRotateTemplate | ( | const DiColorPixel * | pixel,
|  | const Uint16 | src_cols,
|  | const Uint16 | src_rows,
|  | const Uint16 | dest_cols,
|  | const Uint16 | dest_rows,
|  | const Uint32 | frames,
|  | const int | degree )
| inline

constructor

Parameters

  pixel | pointer to intermediate pixel representation
  src_cols | width of clipping area
  src_rows | height of clipping area
  dest_cols | width of destination image (scaled image)
  dest_rows | height of destination image
  frames | number of frames
  degree | angle by which the pixel data should be rotated

References DiColorPixel::DiColorPixel(), DiColorPixelTemplate< T >::DiColorPixelTemplate(), DiRotateTemplate< T >::DiRotateTemplate(), and DiPixel::getCount().

## Member Function Documentation

## ◆ rotate()

template<class T>

void DiColorRotateTemplate< T >::rotate | ( | const T * | pixel[3],
|  | const int | degree )
| inline private

rotate pixel data

Parameters

  pixel | pointer to pixel data (3 components) to be rotated
  degree | angle by which the pixel data should be rotated

References DiColorPixelTemplate< T >::Data, DiColorPixelTemplate< T >::Init(), DiRotateTemplate< T >::rotateLeft(), DiRotateTemplate< T >::rotateRight(), and DiRotateTemplate< T >::rotateTopDown().

The documentation for this class was generated from the following file:

- dcmimage/include/dcmtk/dcmimage/dicorot.h

Generated on Sat Mar 1 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2